/***********************************
 * #include <disclaimer.h>  //this C code is going make this program run faster :)
 * Author: Narendranath D.
 ***********************************/


import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.util.Hashtable;
import java.text.*;
import java.io.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;
import javax.swing.text.*;
import com.ibm.mq.*;

public class MQMessenger extends JFrame 
{
    private JTextField txtqm = new JTextField(15),
                        txtqn = new JTextField(15),
                        txtreplyq = new JTextField(12);
    private JTextArea msgTextArea = new JTextArea();
    private JButton browseb = new JButton("Browse"),
                    getb = new JButton("Get"),
                    postb = new JButton("Post"),
                    optionsb = new JButton("Options"),
                    browseallb = new JButton("Browse All"),
                    getallb = new JButton("Get All"),
                    postnb = new JButton("Multi-Post"),
                    //closeb = new JButton("Close");
                    clearb = new JButton("Clear Queue");
    private OptionsDialog opt_dlg;
    private PosterDialog post_dlg;
    private JFileChooser dirChooser = new JFileChooser(".");
    public static Hashtable properties = new Hashtable();
    private String strQManager = "";
    private String strQName = "";

    public MQMessenger() {
        super("MQMessenger Application");

        //Read the properties file for default values
        try {
                ResourceBundle defaults = ResourceBundle.getBundle("MQMessenger");

                //Fill the properties hashtable
                strQManager = defaults.getString("mqmanager");
                strQName = defaults.getString("mqqueue");
                properties.put(MQC.HOST_NAME_PROPERTY, defaults.getString("mqhost"));
                properties.put(MQC.CHANNEL_PROPERTY, defaults.getString("mqchannel"));
                properties.put(MQC.PORT_PROPERTY, new Integer(defaults.getString("mqport")));
                properties.put("mqcharset", new Integer(defaults.getString("mqcharset")));
                properties.put("mqcharlength", new Integer(defaults.getString("mqcharlength")));
                properties.put(MQC.TRANSPORT_PROPERTY, MQC.TRANSPORT_MQSERIES);
        }
        catch (MissingResourceException ex)
        {
                System.out.print("Missing required values from the MQMessenger.properties file....");
                System.exit(0);
        }
        catch (NumberFormatException nu)
        {
                System.out.print("bad number format in MQMessenger.properties...");
                System.exit(0);
        }		

        //start building the app window
        setSize(700, 600);

        JPanel qp = new JPanel(); //Top panel containing QM and QN
        qp.setLayout(new GridBagLayout());
        GridBagConstraints c = new GridBagConstraints();

        qp.add(new JLabel("Q Manager "),c);
        qp.add(txtqm);
        txtqm.setText(strQManager);

        qp.add(new JLabel("    Q Name "),c);
        qp.add(txtqn);
        txtqn.setText(strQName);
        
        qp.add(new JLabel("    Reply to Q "),c);
        qp.add(txtreplyq);

        getContentPane().add(qp, BorderLayout.NORTH);

        JPanel msgp = new JPanel(new BorderLayout()); //message panel to contain message text
        msgp.setBorder(new TitledBorder(new EtchedBorder(), "Message"));

        JScrollPane scrollp = new JScrollPane(msgTextArea); //place the text area in a scroll pane
        msgp.add(scrollp, BorderLayout.CENTER); //add the scroll pane to message panel
        getContentPane().add(msgp, BorderLayout.CENTER);  // add the message pane to the main panel

        JPanel buttonp = new JPanel();
        buttonp.setLayout(new GridLayout(2, 4, 5, 5));

        ////////////////////////////////////////////////
        // Add Browse button
        ///////////////////////////////////////////////
        ActionListener browseAct = new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                strQManager = txtqm.getText();//get it from the text area
                strQName = txtqn.getText();//get it from the text area
                String message="";  //message string

                if ( ((strQManager != null) && (strQManager.length() != 0)) &&
                        ((strQName != null) && (strQName.length() != 0)) )
                {
                    MQHelper mh = new MQHelper(MQMessenger.properties);
                    message = mh.browseMessage(strQManager, strQName);
                } else {
                        message = "ERROR: enter Queue Manger Name and Queue Name...";
                }//endif
                //populate the message text area with the retrieved message
                msgTextArea.setText(message);
            }//end Action performed
        }; //end ActionListener class

        browseb.addActionListener(browseAct);
        buttonp.add(browseb);

        ////////////////////////////////////////
        // Add Get button
        ////////////////////////////////////////
        ActionListener getAct = new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                strQManager = txtqm.getText();//get it from the text area
                strQName = txtqn.getText();//get it from the text area
                String message="";  //message string

                if ( ((strQManager != null) && (strQManager.length() != 0)) &&
                        ((strQName != null) && (strQName.length() != 0)) )
                {
                    MQHelper mh = new MQHelper(MQMessenger.properties);
                    message = mh.getMessage(strQManager, strQName);
                } else {
                    message = "ERROR: enter Queue Manger Name and Queue Name...";
                }//endif
                //populate the message text area with the retrieved message
                msgTextArea.setText(message);
            }//end Action performed
        };

        getb.addActionListener(getAct);
        buttonp.add(getb);

        //////////////////////////////////////
    	//Add Post button
        //////////////////////////////////////
	ActionListener postAct = new ActionListener() {
    	   public void actionPerformed(ActionEvent e) {
		String postMsg = msgTextArea.getText();
		if(postMsg.length() == 0)
		{
		    return;
		}
		String strQManager = txtqm.getText();//get it from the text area
		String strQName = txtqn.getText();//get it from the text area
                String strReplyQ = txtreplyq.getText();
		String message="";  //message string

		if ( ((strQManager != null) && (strQManager.length() != 0)) &&
                    ((strQName != null) && (strQName.length() != 0)) ) {
                        MQHelper mh = new MQHelper(MQMessenger.properties);
                        if(!mh.postMessage(strQManager, strQName, postMsg, strReplyQ)) {
                            message = mh.getErrorString();
                        }
                } else {
                    message = "ERROR: enter Queue Manger Name and Queue Name...";
                }//endif
                msgTextArea.setText(message);
	   }//end Action performed
 	};

 	postb.addActionListener(postAct);
	buttonp.add(postb);

        ////////////////////////////////
        //Add Options button
        ////////////////////////////////
	ActionListener optAct = new ActionListener() {
            public void actionPerformed(ActionEvent e) {

                Dimension d1 = opt_dlg.getSize();
                Dimension d2 = MQMessenger.this.getSize();
                int x = Math.max((d2.width-d1.width)/2, 0);
                int y = Math.max((d2.height-d1.height)/2, 0);
                opt_dlg.setBounds(x+MQMessenger.this.getX(), 
                        y+ MQMessenger.this.getY(),
                        d1.width, d1.height);
                opt_dlg.show();
            }
	};

	optionsb.addActionListener(optAct);
	buttonp.add(optionsb);

        ////////////////////////////////////////
        //Add Browse All button
        ///////////////////////////////////////
	ActionListener browseallAct = new ActionListener() {
            public void actionPerformed(ActionEvent e) {
		strQManager = txtqm.getText();//get it from the text area
		strQName = txtqn.getText();//get it from the text area
		String message="";  //message string
                if ( ((strQManager == null) || (strQManager.length() == 0)) ||
			((strQName == null) || (strQName.length() == 0)) )
		{
                    msgTextArea.setText("ERROR: enter Queue Manger Name and Queue Name...");
                    return;
		}

                String dirName; //Directory to where the messages should be written
                
                SimpleDateFormat formatter = new SimpleDateFormat ("ssmmhhddMMyyyy");
                Date currentTime = new Date();
                String baseName = strQName + "_" + formatter.format(currentTime) + "_";
                //System.out.print(baseName);
               
                dirChooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
                int state = dirChooser.showOpenDialog(MQMessenger.this);
                File dir = dirChooser.getSelectedFile();
                if(dir != null && state == JFileChooser.APPROVE_OPTION)
                {
                    dirName = dir.getPath();
                    dirName = dirName + File.separator;
                    //System.out.print(dirName);
                }
                else {
                    return;  //do nothing and return
                }
                
                MQHelper mh = new MQHelper(MQMessenger.properties);
                if(!mh.browseMessages(strQManager, strQName, dirName, baseName)) {
                    message = mh.getErrorString();
                } else {
                    message = "All messages were written to files...";
                }//endif
                msgTextArea.setText(message);
	    }//end Action performed
 	}; //end ActionListener class

 	browseallb.addActionListener(browseallAct);        
	buttonp.add(browseallb);

        ///////////////////////////////
        //Add Get All button
        ///////////////////////////////
	ActionListener getallAct = new ActionListener() {
            public void actionPerformed(ActionEvent e) {
		strQManager = txtqm.getText();//get it from the text area
		strQName = txtqn.getText();//get it from the text area
		String message="";  //message string
                if ( ((strQManager == null) || (strQManager.length() == 0)) ||
			((strQName == null) || (strQName.length() == 0)) )
		{
                    msgTextArea.setText("ERROR: enter Queue Manger Name and Queue Name...");
                    return;
		}
                String dirName; //Directory to where the messages should be written
                
                SimpleDateFormat formatter = new SimpleDateFormat ("ssmmhhddMMyyyy");
                Date currentTime = new Date();
                String baseName = strQName + formatter.format(currentTime) + "_";
                //System.out.print(baseName);
               
                dirChooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
                int state = dirChooser.showOpenDialog(MQMessenger.this);
                File dir = dirChooser.getSelectedFile();
                if(dir != null && state == JFileChooser.APPROVE_OPTION)
                {
                    dirName = dir.getPath();
                    dirName = dirName + File.separator;
                    //System.out.print(dirName);
                }
                else {
                    return; //do nothing and return
                }
                
                MQHelper mh = new MQHelper(MQMessenger.properties);
                if(!mh.getMessages(strQManager, strQName, dirName, baseName)) {
                    message = mh.getErrorString();
                } else {
                    message = "All messages were written to files...";
                }//endif
                msgTextArea.setText(message);                
                //get all the messages from the queue
       		
   		//populate the message text area with the status message
               	msgTextArea.setText(message);
  
	    }//end Action performed
 	}; //end ActionListener class

 	getallb.addActionListener(getallAct);  
	buttonp.add(getallb);

        ///////////////////////////////////
        //Add Multi-post button
        ////////////////////////////////////
	ActionListener postnAct = new ActionListener() {
            public void actionPerformed(ActionEvent e) {
		strQManager = txtqm.getText();//get it from the text area
		strQName = txtqn.getText();//get it from the text area
		String message="";  //message string
                if ( ((strQManager == null) || (strQManager.length() == 0)) ||
			((strQName == null) || (strQName.length() == 0)) )
		{
                    msgTextArea.setText("ERROR: enter Queue Manger Name and Queue Name...");
                    return;
		}
                
                if( msgTextArea.getText().length()== 0 ) {
                    return;
                }
                
                post_dlg.setQManager(strQManager);
                post_dlg.setQName(strQName);
                post_dlg.setMessage(msgTextArea.getText());
                
                Dimension d1 = post_dlg.getSize();
		Dimension d2 = MQMessenger.this.getSize();
		int x = Math.max((d2.width-d1.width)/2, 0);
		int y = Math.max((d2.height-d1.height)/2, 0);
		post_dlg.setBounds(x+MQMessenger.this.getX(), 
			y+ MQMessenger.this.getY(), d1.width, d1.height);
		post_dlg.show();
                
	    }//end Action performed
 	}; //end ActionListener class

 	postnb.addActionListener(postnAct);  
	buttonp.add(postnb);

        /////////////////////////////////
        // Add Clear Queue button
        ////////////////////////////////
        ActionListener clearAct = new ActionListener() {
    	   public void actionPerformed(ActionEvent e) {
		String strQManager = txtqm.getText();//get it from the text area
		String strQName = txtqn.getText();//get it from the text area
		String message="";  //message string

		if ((strQManager.length() != 0) &&  (strQName.length() != 0)) {
                        MQHelper mh = new MQHelper(MQMessenger.properties);
                        if(!mh.clearMessages(strQManager, strQName)) {
                            message = mh.getErrorString();
                        } else {
                            message = "Cleared all messages from the queue....";
                        }
                } else {
                    message = "ERROR: enter Queue Manger Name and Queue Name...";
                }//endif
                msgTextArea.setText(message);
	   }//end Action performed
 	};
        
        clearb.addActionListener(clearAct);
	buttonp.add(clearb);
        
        
	ActionListener closeAct = new ActionListener() {
    	   	public void actionPerformed(ActionEvent e) {
			System.exit(0);
		}
	};
	
	getContentPane().add(buttonp, BorderLayout.SOUTH);

        WindowListener wndCloser = new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
                System.exit(0);
            }
        };
        addWindowListener(wndCloser);
        
        setVisible(true);

        opt_dlg = new OptionsDialog(this);
        post_dlg = new PosterDialog(this);

  }

  public static void main(String argv[]) {
    new MQMessenger();
  }
}


class OptionsDialog extends JDialog
{
  private JTextField txtHost, txtChannel, txtPort, txtCharset, txtCharsize;
  private JButton okb, cancelb;

  public OptionsDialog(JFrame parent)
  {
	super(parent, "Options", true);

	Container basePane = getContentPane();
        basePane.setLayout(new BorderLayout(2,2));
        
        JPanel labelPanel = new JPanel();
        labelPanel.setLayout(new GridLayout(5,1,2,2));
        labelPanel.add(new JLabel("Host "));
        labelPanel.add(new JLabel("Channel"));
        labelPanel.add(new JLabel("Port"));
        labelPanel.add(new JLabel("Character set"));
        labelPanel.add(new JLabel("Character size"));
        basePane.add(labelPanel, BorderLayout.WEST);
        
        JPanel textPanel = new JPanel();
        textPanel.setLayout(new GridLayout(5,1,2,2));
        
        txtHost = new JTextField(30);
	textPanel.add(txtHost);
	txtHost.setText((String) MQMessenger.properties.get(MQC.HOST_NAME_PROPERTY));
        txtChannel = new JTextField(30);
	textPanel.add(txtChannel);
	txtChannel.setText((String) MQMessenger.properties.get(MQC.CHANNEL_PROPERTY));
        txtPort = new JTextField(6);
	textPanel.add(txtPort);
	txtPort.setText(((Integer) MQMessenger.properties.get(MQC.PORT_PROPERTY)).toString());
        txtCharset = new JTextField(6);
	textPanel.add(txtCharset);
	txtCharset.setText(((Integer) MQMessenger.properties.get("mqcharset")).toString());
        txtCharsize = new JTextField(6);
	textPanel.add(txtCharsize);
	txtCharsize.setText(((Integer) MQMessenger.properties.get("mqcharlength")).toString());
        basePane.add(textPanel, BorderLayout.EAST);
        
        JPanel buttonPanel = new JPanel();
	okb = new JButton("OK");
	buttonPanel.add(okb);
        cancelb = new JButton("CANCEL");
	buttonPanel.add(cancelb);
        basePane.add(buttonPanel, BorderLayout.SOUTH);
        
	ActionListener okbAct = new ActionListener() {
    	   	public void actionPerformed(ActionEvent e) {
                    MQMessenger.properties.put(MQC.HOST_NAME_PROPERTY, txtHost.getText());
                    MQMessenger.properties.put(MQC.CHANNEL_PROPERTY, txtChannel.getText());
                    MQMessenger.properties.put(MQC.PORT_PROPERTY, new Integer(txtPort.getText()));
                    MQMessenger.properties.put("mqcharset", new Integer(txtCharset.getText()));
                    MQMessenger.properties.put("mqcharlength", new Integer(txtCharsize.getText()));
                    //setVisible(false);
                    dispose();
  
	   	}//end Action performed
 	}; //end ActionListener class

 	okb.addActionListener(okbAct);

	ActionListener cancelbAct = new ActionListener() {
    	   	public void actionPerformed(ActionEvent e) {
                    //reset the text fields with the values from the properties hashtable
                    txtHost.setText((String) MQMessenger.properties.get(MQC.HOST_NAME_PROPERTY));
                    txtChannel.setText((String) MQMessenger.properties.get(MQC.CHANNEL_PROPERTY));
                    txtPort.setText(((Integer) MQMessenger.properties.get(MQC.PORT_PROPERTY)).toString());
                    txtCharset.setText(((Integer) MQMessenger.properties.get("mqcharset")).toString());
                    txtCharsize.setText(((Integer) MQMessenger.properties.get("mqcharlength")).toString());
                    dispose();
	   	}//end Action performed
 	}; //end ActionListener class

 	cancelb.addActionListener(cancelbAct);
	pack();
    	setResizable(false);
  }
  
}


class PosterDialog extends JDialog{
  private JTextField txtCount;
  private String replytoq = "";
  private String message = "";
  private JButton okb, cancelb;
  private String QManager, QName;
  

  public PosterDialog(JFrame parent)
  {
	super(parent, "Post Message", true);
	Container basePane = getContentPane();
        basePane.setLayout(new BorderLayout(2,2));
        
        JPanel counterPanel = new JPanel();
        counterPanel.setLayout(new FlowLayout());
        counterPanel.add(new JLabel("How many times? "));
        txtCount = new JTextField(10);
        counterPanel.add(txtCount);
        basePane.add(counterPanel, BorderLayout.NORTH);
        
        JPanel buttonPanel = new JPanel();
	okb = new JButton("OK");
	buttonPanel.add(okb);
        cancelb = new JButton("CANCEL");
	buttonPanel.add(cancelb);
        basePane.add(buttonPanel, BorderLayout.SOUTH);
 
        txtCount.setDocument(new IntegerDocument());
        
        ActionListener okbAct = new ActionListener() {
    	   public void actionPerformed(ActionEvent e) {
               int i = 0;
               if(txtCount.getText().length() != 0) {
                    i = Integer.parseInt(txtCount.getText());
                    MQHelper mh = new MQHelper(MQMessenger.properties);
                    //String qm, String qn, String msgtopost, String replyq, int n
                    if(mh.postMessages(QManager, QName, message, replytoq, i)) {
                        System.out.print(mh.getErrorString());
                    }
               }
               txtCount.setText("0");
               dispose();
  
	   }//end Action performed
 	}; //end ActionListener class

 	okb.addActionListener(okbAct);

	ActionListener cancelbAct = new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                txtCount.setText("0");
                dispose();
	    }//end Action performed
 	}; //end ActionListener class

 	cancelb.addActionListener(cancelbAct);
	pack();
    	setResizable(false);
  }
  
  public void setReplytoq(String qname) {
      replytoq = qname;
  }
  public void setMessage(String msg){
      message = msg;
  }
  public void setQManager(String qm) {
      QManager = qm;
  }
  public void setQName(String qn) {
      QName = qn;
  }
}

class IntegerDocument extends PlainDocument {
    public void insertString(int offset, String s, AttributeSet attributeSet) throws BadLocationException {
        try {
            Integer.parseInt(s);
        }
        catch (Exception ex) {
            Toolkit.getDefaultToolkit().beep();
            return;
        }
        super.insertString(offset, s, attributeSet);
    }
}
